abclinuxu.cz AbcLinuxu.cz itbiz.cz ITBiz.cz HDmag.cz HDmag.cz abcprace.cz AbcPráce.cz
AbcLinuxu hledá autory!
Inzerujte na AbcPráce.cz od 950 Kč
Rozšířené hledání
×

včera 21:33 | Bezpečnostní upozornění

V Sambě byla nalezena a opravena bezpečnostní chyba CVE-2017-7494. Má-li útočník právo ukládat soubory na vzdálený server, může tam uložit připravenou sdílenou knihovnu a přinutit smbd server k jejímu načtení a tím pádem ke spuštění libovolných příkazů. Chyba je opravena v upstream verzích 4.6.4, 4.5.10 a 4.4.14. Chyba se týká všech verzí Samby od verze 3.5.0 vydané 1. března 2010.

Ladislav Hagara | Komentářů: 0
včera 20:44 | Nová verze

Byla vydána nová stabilní verze 4.3.0 integrovaného vývojového prostředí (IDE) Qt Creator. Z novinek lze zmínit například integraci editoru kódu do Qt Quick Designeru.

Ladislav Hagara | Komentářů: 0
včera 20:11 | Bezpečnostní upozornění

Společnost Check Point informuje na svém blogu o novém vektoru útoku. Pomocí titulků lze útočit na multimediální přehrávače VLC, Kodi, Popcorn Time, Stremio a pravděpodobně i další. Otevření útočníkem připraveného souboru s titulky v neaktualizovaném multimediálním přehrávači může vést ke spuštění libovolných příkazů pod právy uživatele. Ukázka na YouTube. Chyba je opravena v Kodi 17.2 nebo ve VLC 2.2.6.

Ladislav Hagara | Komentářů: 1
23.5. 15:18 | Zajímavý software

CrossOver, komerční produkt založený na Wine, je dnes (23. 5. 2017) dostupný ve slevě. Roční předplatné linuxové verze vyjde s kódem TWENTYONE na $21, resp. $1 v případě IP z chudších zemí. Firma CodeWeavers, která CrossOver vyvíjí, významně přispívá do Wine. Přidaná hodnota CrossOver spočívá v přívětivějším uživatelském rozhraní, integraci do desktopu a podpoře.

Fluttershy, yay! | Komentářů: 24
23.5. 15:11 | Zajímavý projekt

V únoru loňského roku bylo představeno několik útoků na celou řadu bezdrátových klávesnic a myší s názvem MouseJack. Po více než roce lze chybu opravit, tj. aktualizovat firmware, také z Linuxu. Richardu Hughesovi se podařilo navázat spolupráci se společností Logitech, získat od nich dokumentaci, přesvědčit je, aby firmware poskytovali přímo a ne jako součást .exe souboru, aby mohl být popis začleněn do služby Linux Vendor Firmware Service (LVFS) a aktualizace tak mohla proběhnou přímo z Linuxu pomocí projektu fwupd.

Ladislav Hagara | Komentářů: 2
23.5. 13:22 | Nová verze

Po roce a půl vydali vývojáři projektu SANE (Scanner Access Now Easy) (Wikipedie) novou verzi 1.0.27 balíku SANE-Backends. Nejnovější verze tohoto balíku pro přístup ke skenerům přináší například významná vylepšení v několika backendech nebo podporu pro více než 30 nových modelů skenerů. Verze 1.0.26 byla přeskočena.

Ladislav Hagara | Komentářů: 0
22.5. 20:55 | Komunita

Od 18. do 21. května proběhla v Saint-Étienne Linux Audio Conference 2017. Na programu byla řada zajímavých přednášek a seminářů. Videozáznamy přednášek lze zhlédnout na YouTube. K dispozici jsou také články a prezentace.

Ladislav Hagara | Komentářů: 0
22.5. 20:44 | IT novinky

Hodnota Bitcoinu, decentralizované kryptoměny, překonala hranici 2 200 dolarů. Za posledních 30 dnů tak vzrostla přibližně o 80 % [reddit].

Ladislav Hagara | Komentářů: 8
22.5. 17:33 | Nová verze

Po 5 měsících vývoje od vydání verze 0.12.0 byla vydána verze 0.13.0 správce balíčků GNU Guix a na něm postavené systémové distribuce GuixSD (Guix System Distribution). Na vývoji se podílelo 83 vývojářů. Přibylo 840 nových balíčků. Jejich aktuální počet je 5 454. Aktualizována byla také dokumentace.

Ladislav Hagara | Komentářů: 1
22.5. 17:22 | Nová verze

Po 5 měsících vývoje a 3 týdnech intenzivního testování byla vydána verze 12 open source systému Nextcloud, forku ownCloudu, umožňujícího provoz vlastního cloudového úložiště. Přehled novinek i s videoukázkami v poznámkách k vydání. Pro vyzkoušení je k dispozici demo.

Ladislav Hagara | Komentářů: 10
Chystáte se pořídit CPU AMD Ryzen?
 (6%)
 (32%)
 (1%)
 (8%)
 (44%)
 (9%)
Celkem 607 hlasů
 Komentářů: 62, poslední 19.5. 01:57
    Rozcestník

    Dotaz: návratová hodnota taru nefunguje

    27.5.2011 20:29 mhh
    návratová hodnota taru nefunguje
    Přečteno: 224×
    # tar -c -T $seznam | bzip2 -9 >$sambacesta`date +%y_%m_%d`'.tar.bz2' && echo "Backup Done"  || "Backup Failed"

    Proč toto nemůže fungovat? Díky

    Odpovědi

    27.5.2011 20:36 Kit
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Asi proto, že se bere návratová hodnota posledního programu v koloně, tedy bzip2.
    Jendа avatar 27.5.2011 20:36 Jendа | skóre: 73 | blog: Výlevníček | JO70FB
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Tak předně je tam chyba syntaxe, správně je to
    tar -c -T $seznam | bzip2 -9 >$sambacesta`date +%y_%m_%d`'.tar.bz2' && echo "Backup Done"  || echo "Backup Failed"
    Ale ani to nebude fungovat na návratovou hodnotu taru, protože se uvažuje vždy poslední návratová hodnota v koloně - v tomhle případě bzipu.
    27.5.2011 21:09 mhh
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    tar -cjvf -T $seznam soubor.tar.bz2 && echo "Backup Done" || echo "Backup Failed"
    Něco mi řiká, že tam je chyba v těch parametrech, že?
    Jendа avatar 27.5.2011 21:23 Jendа | skóre: 73 | blog: Výlevníček | JO70FB
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    JJ, název výsledného souboru musí následovat hned za -f.
    27.5.2011 21:30 mhh
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    seznam=/home/user/list
    tar -cjvf  soubor.tar.bz2 -T $seznam && echo "Backup Done" || echo "Backup Failed"
    Toto ovšem taky nefunguje :D
    Jendа avatar 27.5.2011 21:42 Jendа | skóre: 73 | blog: Výlevníček | JO70FB
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    A copak to píše? Já nemám soubor /home/user/list, ale v rámci možností to u mě vypadá funkční.
    28.5.2011 11:22 Ash | skóre: 53
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    mně to funguje
    28.5.2011 13:07 Patrik Uhrak | skóre: 31 | blog: pato
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Aj tu to funguje. Problem je prave v tom, co tu poznamenal Jenda vo svojom prispevku. Pre navratovu hodnotu sa berie navratova hodnota posledneho
    prikazu v kolone. A to je echo. Echo vracia VZDY ako navratovu hodnotu 0 teda true. Takze takto to ani nikdy fungovat nebude:

    seznam=/home/user/list
    tar -cjvf  soubor.tar.bz2 -T $seznam && echo "Backup Done" || echo "Backup Failed"
    if [[ $? -eq 0 ]]
    then
             rob_nieco
    else
             rob_nieco_ine_ked_sa_to_nepodarilo
    fi

    Alebo nieco na ten sposob. Ak je to skript, tak by sa mohlo trebars spravit to takto:

    #! /bin/bash
    seznam=/home/user/list
    
    VytvorArchiv(){
    # Echo vracia VZDY true, takze ak prebehne uspesne vytvorenie archivu, tak nie je nutne nic robit.
    tar -cjvf  soubor.tar.bz2 -T "${1}" && echo "Backup Done" || ( echo "Backup Failed"; return 1 )
    }
    
    if VytvorArchiv "${seznam}"
    then
            rob_nieco
    else
           rob_nieco_ine_ked_sa_to_nepodarilo
    fi
    Takto by to malo fungovat. Ale ak je to tento pripad, tak je to jednoznacne chyba zadavatela, kedze neposkytol dostatok informacii. ;)
    Jendа avatar 28.5.2011 13:14 Jendа | skóre: 73 | blog: Výlevníček | JO70FB
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Mně ale konstrukce && || funguje podle očekávání:
    ~> true && echo ok || echo fail
    ok
    ~> false && echo ok || echo fail
    fail
    
    28.5.2011 13:48 Patrik Uhrak | skóre: 31 | blog: pato
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje

    Aj mne. Mozno som sa len nedostatocne vyjadril. Ale taketo nieco nefunguje a to je jediny pre mna zjavny dovod, preco by to zadavatelovi "nefungovalo":

    patrik@debian-thinkpad:~$ true && echo ok || echo fail; [[ $? -eq 0 ]] && echo ok
    ok
    ok
    patrik@debian-thinkpad:~$ false && echo ok || echo fail; [[ $? -eq 0 ]] && echo ok
    fail
    ok

    Ja len vravim, ze nemoze pouzit nieco taketo a vraviet, ze tar vracia nespravnu navratovu hodnotu:

    #! /bin/bash
    true && echo ok || echo fail
    if [[ $? -eq 0 ]]; then rob_nieco; else rob_nieco_ine; fi

    Takto to totiz nebude nikdy fungovat skrz pouzitia echo, ktory ma vzdy navratovu hodnotu 0 a teda maskuje navratovu hodnotu true resp. akehokolvek prikazu pred echo-m v kolone. Da sa to vsak vyriesit napr. aj nasledovne:

    #! /bin/bash
    Funkcia(){
    true && echo ok || ( echo fail; return 1 )
    }
    
    if funkcia; then rob_nieco; else rob_nieco_ine; fi

    To je podla mojho nazoru dovod, preco tu zakladatel stale tvrdi, ze mu tar nevracia spravnu navratovu hodnotu. A to je zaroven aj pointa mojho predchadzajuceho prispevku.

    28.5.2011 14:03 Ash | skóre: 53
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Myslím že tazatel vůbec neměl v úmyslu testovat návratovou hodnotu PO provedení výše uvedených příkazů tar && echo || echo

    To co kolegové řešili ohledně návratové hodnoty v koloně byl problém tar | bzip && echo || echo, kde tar a bzip jsou v koloně tar | bzip a následné příkazy echo se řídí návratovou hodnotou bzipu, nikoliv taru.

    tar && echo || echo

    není kolona (v obvyklém smyslu slova, tak byste to tedy nazývat neměl, pokud nejste z Babylonu. Před echome tedy nic v koloně není), je to sled příkazů, po jejich provedení je k dispozici návratová hodnota posledního znich (jedno z ech), jak jste správně řekl.

    Další věc je, že konstrukce
    A && B || C
    je ve skutečnosti
    if (A && B) then B; else C; fi
    , ale v případě přikazů jako echo se to zanedbává, neb většinou fungují.
    28.5.2011 14:32 Patrik Uhrak | skóre: 31 | blog: pato
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje

    Nereagoval som na temu po tento prispevok: https://www.abclinuxu.cz/poradna/linux/show/336497#6

    To bol dovod a myslim, ze stale je dovodom, preco som vyvodil z toho zaver, aky som vyvodil a myslim, ze pravom som sa domnieval, ze tam nasleduje kontrola v dalsom kode na navratovu hodnotu. Ale pockajme si na zakladatela temy.

    Co sa tyka kolony, z Babylonu nie som. :) Popravde som sa nad vyznamom slova nezamyslal az natolko. Viac som sa snazil tu udrzat nejake jednotne nazvoslovie, ktore Jenda nastolil. Jenda ho vsak pouzil spravne, teda pokial tu budeme sledovat vase vysvetlenie ohladne kolony ( logicke vysvetlenie ), pretoze on spominal aj bzip v case pisania toho jeho prispevku. Inak by som temer isto pouzil sled prikazov pred kolonou.

    Takze cele moje posobenie v tejto teme nie je o tom, ci vracia tar spravnu navratovu hodnotu alebo nie, kedze je jasne, ze vracia spravnu. Ale o implementacii kodu do nejakeho vacsieho celku a k tejto teorii mi nahrava prave vyssie zmienovany odkaz.

    Jendа avatar 28.5.2011 14:46 Jendа | skóre: 73 | blog: Výlevníček | JO70FB
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Další věc je, že konstrukce
    A && B || C
    je ve skutečnosti
    if (A && B) then B; else C; fi
    , ale v případě přikazů jako echo se to zanedbává, neb většinou fungují.
    Ne, to není, protože to druhé by ve skutečnosti (pokud by vše končilo úspěchem) udělalo ABB či ABC (pokud by končilo neúspěchem), zatímco první udělá jen AB, případně AC.
    28.5.2011 15:02 Ash | skóre: 53
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Ale jo, je, jen to neberte doslova ale jako pseudokód ;)

    Doslova by to přsněji udělalo ABB (úspěch) nebo ABC resp. AC (neúspěch, nepovedlo se B resp. A).

    Jistě by to šlo v bash napsat
    if (A && B) then :; else C; fi
    což je sice přesnější, ale zase ne tak srozumitelné. Podstatné na co jsem chtěl upozornit je, že výpis C závisí na pozitivní návratové hodnotě B, k čemuž u if-A-then-B-else-C nedochází. U echa je to jedno, ale někdo by třeba dokázal napsat i (pseudokód:)
    rar && rm .lock || touch .rar-failed 
    což už může vytvořit .rar-failed i v případě, že rar proběhne ok.
    28.5.2011 17:27 mhh
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Zajimave,diky za informace
    28.5.2011 17:53 Ash | skóre: 53
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Doplním ještě jak to tedy vlastně udělat, pokud by návratová hodnota rar byla po skončení příkazů v pajpě potřeba - v Bash je dostupná v poli PIPESTATUS.
    bash$ true | false | true
    bash$ echo ${PIPESTATUS[1]}
    1 # to je to false
    
    27.5.2011 21:09 NN
    Rozbalit Rozbalit vše Re: návratová hodnota taru nefunguje
    Mimochodem tim bzip2 to muzes protahnout primo pres tar:
    tar -cjf foo.tar.bz2 bar/
    
    NN

    Založit nové vláknoNahoru

    Tiskni Sdílej: Linkuj Jaggni to Vybrali.sme.sk Google Del.icio.us Facebook

    ISSN 1214-1267   www.czech-server.cz
    © 1999-2015 Nitemedia s. r. o. Všechna práva vyhrazena.